// perfect.cpp
// CMPT 165 Assignment #1

#include "perfect.h"


bool perfect( int num ) throw( BadInput )
{
	if ( num <= 0 ) throw BadInput();

	if ( num < 4 ) return false;	// we know 1-3 aren't perfect

	// brute force approach:  Loop through all possible factors, multiplying
	// till we hit num bang on or overrun it.  Keep track of the running
	// sum too, and when we hit num, if the sum matches, it's perfect.

	int sum= 1;		// running sum includes factor 1

	// Factor num, adding up the factors as we find 'em
	for ( int f=2; f <= num/2; f++ ) {
		if ( num%f == 0 ) {				// remainder of zero means factor
			sum += f;					// add to running sum
			if ( sum > num ) break;		// bail out when clearly futile
		}
	}

	return ( sum==num );
}