// cheque.h
// CMPT 165 Assignment #2
// test = a2_cheque

#ifndef cheque_h_
#define cheque_h_

#pragma warning( disable : 4290 ) // VC++: don't warn for exception specification


// Function name	: setChequeSym
// Description	    : Sets the currency symbol(s) to be used by chequeAmt
// Argument         : char *string; the null-terminated string to be used
//					  as the currency symbol.  If string==0, the default string
//					  "$" will be restored.

void setChequeSym( char *string );


// Function name	: chequeAmt
// Description	    : Converts an amount of money into an asterisk-filled
//					  ASCII string, null-terminated, with the currency symbol(s)
//					  as its leftmost character(s)
// Argument         : char *buffer; array to be filled with output
// Argument			: int spaces; no. of spaces that will be filled with
//					  printable characters; i.e., buffer[0] through
//					  buffer[spaces-1] will be filled, and buffer[spaces]
//					  will receive a null
// Argument			: unsigned dollars
// Argument			: unsigned cents; if cents > 99, cents/100 will be added
//					  to dollars and cents%100 will be used
// Return			: same as buffer argument
// Exception		: ChequeBufferOverflow; thrown if the printable form of
//					  dollars (and cents, if applicable) requires more spaces
//					  than the caller allowed
// Notes			: The minimum output is "$0" or "$0.00" (spaces = 2 or 5),
//					  for the dollars-only or dollars-and-cents versions,
//					  respectively, assuming the default currency symbol.

class ChequeBufferOverflow{};

char *chequeAmt( char *buffer, int spaces, unsigned dollars, unsigned cents )
				throw( ChequeBufferOverflow );

char *chequeAmt( char *buffer, int spaces, unsigned dollars )
				throw( ChequeBufferOverflow );

#endif